## qemacs 0.4.1.cvs.20190929-1

=== debian/changelog ===
qemacs (0.4.1.cvs.20190929-1) unstable; urgency=low

  * Initial release (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- sunshavi <sunshavi@yahoo.com>  Sun, 29 Sep 2019 16:36:34 +0000
